package com.zswl.cloud.springBtach.server.boot;

import cn.hutool.json.JSONUtil;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.client.service.EnterpriseService;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.interfaces.domain.AllowancePromotionInfo;
import com.xiaoju.open.oil.interfaces.domain.GenPromotionInfo;
import com.xiaoju.open.oil.interfaces.request.QueryGetPromotionRequest;
import com.xiaoju.open.oil.interfaces.request.QueryOrderPromotionListRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniProgramQueryNewOrderRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniQueryCalPriceRequest;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryCalPriceResponse;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryNewOrderResponse;
import com.zhongshu.payment.client.model.order.v2.GoodsResultModel;
import com.zhongshu.payment.client.model.order.v2.OrderResult2Model;
import com.zhongshu.payment.client.model.order.v2.UserSeachOrder2Model;
import com.zhongshu.payment.client.service.v2.OrderService2;
import com.zhongshu.payment.client.service.v2.PaymentService2;
import com.zhongshu.payment.client.type.Channel;
import com.zswl.cloud.shop.client.service.GoodsService;
import com.zswl.cloud.shop.client.service.ShopService;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.SubmitOrderRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.AddOrderResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.response.SubmitOrderResponse;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.PrivilegeTicketListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.ScenicDetailRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.ScenicListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.response.ScenicListResponse;
import com.zswl.cloud.springBatch.client.model.qiuxiang.OrderRequest;
import com.zswl.cloud.springBatch.client.model.xiaoju.ActivityModel;
import com.zswl.cloud.springBatch.client.model.ypp.kfc.response.CityListResponse;
import com.zswl.cloud.springBatch.client.service.DfyHotelService;
import com.zswl.cloud.springBtach.server.core.api.dfy.DomesticHotelApi;
import com.zswl.cloud.springBtach.server.core.api.dfy.TicketApi;
import com.zswl.cloud.springBtach.server.core.api.qiuxiang.QiuXiangApi;
import com.zswl.cloud.springBtach.server.core.api.ypp.KfcApi;
import com.zswl.cloud.springBtach.server.core.api.ypp.YppApi;
import com.zswl.cloud.springBtach.server.core.controller.TestSpringBatch;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuActivityReceiverDao;
import com.zswl.cloud.springBtach.server.core.service.PaymentService;
import com.zswl.cloud.springBtach.server.core.service.impl.DfyTicketServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.OrderServiceImpl;
import com.zswl.cloud.springBtach.server.core.service.impl.XiaoJuServiceImpl;
import lombok.extern.log4j.Log4j2;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.domain.Page;
import org.springframework.data.mongodb.core.MongoTemplate;

import java.math.BigDecimal;
import java.util.List;

@SpringBootTest
@Log4j2
public class ServerApplicationTests {
    @Autowired
    YppApi piaoPiaoApi;

    @Autowired
    TestSpringBatch testSpringBatch;

    @Autowired
    OrderServiceImpl orderService;


    @Autowired
    EnterpriseService enterpriseService;

    @Autowired
    PaymentService2 paymentService2;


    @Autowired
    PaymentService paymentService;

    @Autowired
    QiuXiangApi qiuXiangApi;

    @Autowired
    TicketApi diFengYunApi;

    @Autowired
    DfyHotelService dfyHotelService;
    @Autowired
    private XiaoJuServiceImpl xiaoJuServiceImpl;
    @Autowired
    private XiaoJuActivityReceiverDao xiaoJuActivityReceiverDao;
    @Autowired
    private KfcApi kfcApi;

    @Test
    public void dfy() {


        ScenicListRequest scenic = new ScenicListRequest();
        scenic.setKey("南京");
        scenic.setPage(1);
        scenic.setPageSize(10);


        ScenicListResponse scenicListResponse = diFengYunApi.scenicList(scenic);
        System.out.println(JSONUtil.toJsonStr(scenicListResponse));


        ScenicDetailRequest scenicDetailRequest = new ScenicDetailRequest();
        scenicDetailRequest.setScenicId("poi1745");

//        ScenicDetailResponse scenicDetailResponse = diFengYunApi.scenicDetail(scenicDetailRequest);
//        System.out.println(JSONUtil.toJsonStr(scenicDetailResponse));

        PrivilegeTicketListRequest privilegeTicketListRequest = new PrivilegeTicketListRequest();
        privilegeTicketListRequest.setPage(1);
        privilegeTicketListRequest.setPageSize(20);

//        PrivilegeTicketListResponse scenicListResponse = diFengYunApi.privilegeTicketList(privilegeTicketListRequest);
//        System.out.println(JSONUtil.toJsonStr(scenicListResponse));

    }


    @Autowired
    DomesticHotelApi domesticHotelApi;

    @Test
    public void hotel() {
//        CancelOrderRequest cancelOrderRequest = new CancelOrderRequest();
//        cancelOrderRequest.setOrderId("1248207159");
//
//        CancelOrderResponse cancelOrderResponse = domesticHotelApi.cancelOrder(cancelOrderRequest);
//        System.out.println(JSONUtil.toJsonStr(cancelOrderResponse));


         orderService2.orderInfo("1798294662177759232");
        ResultContent<List<GoodsResultModel>> listResultContent = orderService2.goodsDetail("1798294662177759232");
        GoodsResultModel goodsResultModel = listResultContent.getContent().get(0);
        BigDecimal payAmount = goodsResultModel.getPayAmount();

        String extend = goodsResultModel.getExtend();
        AddOrderResponse.Datas bean = JSONUtil.toBean(extend, AddOrderResponse.Datas.class);


        SubmitOrderRequest submitOrderRequest = new SubmitOrderRequest();
        submitOrderRequest.setOrderId(bean.getOrderId());
        submitOrderRequest.setPayType(1);
        submitOrderRequest.setPay(String.valueOf(payAmount));

        SubmitOrderResponse submitOrderResponse = domesticHotelApi.submitOrder(submitOrderRequest);
        System.out.println(submitOrderResponse);
    }


    @Autowired
    ShopService shopService;

    @Test
    public void test3() {
        CityListResponse cityListResponse = kfcApi.cityList();

    }


    @Autowired
    GoodsService goodsService;

    @Autowired
    OrderService2 orderService2;
    @Autowired
    MongoTemplate mongoTemplate;


    @Autowired
    OilConfig oilConfig;

    @Test
    public void queryNewOrderq1() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setOutUserId("65fe583d74d67a7dbd842b45");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        newOrderRequest.setMobile("13368172379");

        com.xiaoju.open.oil.interfaces.domain.AllowanceInfo allowanceInfo = new com.xiaoju.open.oil.interfaces.domain.AllowanceInfo();

        newOrderRequest.setPromotionInfo(List.of());


        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);
        System.out.println(response);

    }

    // 下单前查询最优可用券
    @Test
    public void queryOrderPromotionList() {
        QueryOrderPromotionListRequest request = new QueryOrderPromotionListRequest();
        request.setOutUserId("80200281708");
        request.setStoreId("5429504232738269218");
        request.setAllowanceType(2);
        request.setOrderAmount(24500);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<AllowancePromotionInfo> response = queryClient.promotion().queryOrderPromotionList(request);
        System.out.println(response);
    }


    // 券发放
    @Test
    public void getPromotion() {
        QueryGetPromotionRequest request = new QueryGetPromotionRequest();
        request.setOutUserId("18874");
        request.setActivityId("872933491179388928");
        request.setTradeNo("2202071307003069990");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<GenPromotionInfo> response = queryClient.promotion().getPromotion(request);
        System.out.println(response);
    }

    @Test
    public void queryCalPrice() {
        MiniQueryCalPriceRequest calPriceRequest = new MiniQueryCalPriceRequest();
        calPriceRequest.setStoreId("5429780558166639664");
        calPriceRequest.setAmount(10000);
        calPriceRequest.setItemName("92#");
        calPriceRequest.setOpenChannel(1);
        calPriceRequest.setOutUserId("65fe583d74d67a7dbd842b45");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryCalPriceResponse response = queryClient.apiMini().queryCalPrice(calPriceRequest);
        System.out.println(JSONUtil.toJsonStr(response));

    }

    @Test
    public void queryNewOrder() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setOutUserId("1640563200");
        newOrderRequest.setMobile("13368172379");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);

    }

    @Autowired
    DfyTicketServiceImpl dfyTicketService;

    @Test
    public void sync() {
        UserSeachOrder2Model userSeachOrder2Model = new UserSeachOrder2Model();
        userSeachOrder2Model.setChannel(Channel.ZhongShu);
        userSeachOrder2Model.setUserId("660a534e32e63427d1a09c2a");
        ResultContent<Page<OrderResult2Model>> pageResultContent = orderService2.userSearch(userSeachOrder2Model);
        System.out.println(JSONUtil.toJsonStr(pageResultContent));
    }


}
